// Genesaver: copyright 2003 Sam Stafford.

//Enums, constants, and the like.
enum Color { Black, Grey, Green, Red, Blue, Yellow, Cyan, Magenta };

struct Settings
{
	bool AA;
	bool AAline;
	bool shade;
	bool save;
	short mutate;
	short plants; // per 1000 ticks
	short cscale; // percent of default size
	short cspeed; // percent of default speed
	short camera;
	int gticks; // timesteps per screen
	short gwidth; // data points per screen
	short zoom;
	bool wake;
	bool drawvis;
	bool lizard;

	float alpha; //state variable, not setting
};

struct FSettings
{
	float gtime;
	float gstep;
	float ps;
	float pr;
	float ar;
	float am;
	float as;
	float at;
	float av;

	float whratio; //screen width/height ratio

	short ac;
};

extern Settings settings;
extern FSettings fsettings;

#define NULL 0		//null

#define P_E 500.0  	//Plant energy
#define P_R fsettings.pr 	//Plant radius
#define P_C Grey 	//Plant color
#define P_S	fsettings.ps
	//Plant spawning ( number of plants to spawn per step )

#define A_R 5	//Animal radius
#define A_S	5			// Max animal speed
#define A_D 0.1			// Amount of color an animal can eat per step.
#define A_V 30			// Visual distance in image-pixels.

#define D_M settings.mutate	//Number of times to mutate DNA on a split

#define N_R 0.015	//Neuron radius when rendering brain
#define N_L 0.03	//Neuron label "radius"

#define W_P	1		//World population

#define C_WORLD 1	//"World" camera setting
#define C_CHASE 2	//"Chase" camera setting
#define C_GRAPH 3	//"Graph" camera setting

#define G_TIME fsettings.gtime
					//Ticks per graph point
#define G_STEP fsettings.gstep
					//Width in screen coords tween points

#include "util.h"

